Index: /trunk/src/samhain.c
===================================================================
--- /trunk/src/samhain.c	(revision 584)
+++ /trunk/src/samhain.c	(revision 1)
@@ -1970,10 +1506,10 @@
   if (sh.flag.isserver == S_TRUE)
     { 
-      sh_xfer_start_server();
+      sh_receive();
       TPT((0, FIL__, __LINE__, _("msg=<End server.>\n")))
       aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
     }
 #else
-  sh_xfer_start_server();
+  sh_receive();
   TPT((0, FIL__, __LINE__, _("msg=<End server.>\n")))
   aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
@@ -1995,6 +1531,5 @@
   for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
     {
-      status = modList[modnum].mod_init(&(modList[modnum]));
-      if ( status < 0 )
+      if (0 != (status = modList[modnum].mod_init()))
 	{
 	  if (status == (-1)) {
@@ -2002,11 +1537,11 @@
 			     MSG_MOD_FAIL,
 			     _(modList[modnum].name),
-			     status+SH_MOD_OFFSET);
+			     status);
 	  } else {
 	    sh_error_handle ((-1), FIL__, __LINE__, status, MSG_MOD_FAIL,
 			     _(modList[modnum].name),
-			     status+SH_MOD_OFFSET);
+			     status);
 	  }
-	  modList[modnum].initval = SH_MOD_FAILED;
+	  modList[modnum].initval = S_FALSE;
 	}
       else
@@ -2014,5 +1549,5 @@
 	  sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_MOD_OK,
 			   _(modList[modnum].name));
-	  modList[modnum].initval = status;
+	  modList[modnum].initval = S_TRUE;
 	}
     }
@@ -2022,5 +1557,5 @@
   (void) sh_files_setrec();
   (void) sh_files_test_setup();
-  sh_audit_commit ();
+
 
   /* --------  NICE LEVEL   ---------
@@ -2037,15 +1572,8 @@
     }
 
-  /*  --------  CREATE SEMAPHORE  ---------
-   */
-  sh_sem_open();
-
   /*  --------  MAIN LOOP  ---------
    */
-  sh.statistics.bytes_speed   = 0;
-  sh.statistics.bytes_hashed  = 0;
-  sh.statistics.files_report  = 0;
-  sh.statistics.files_error   = 0;
-  sh.statistics.files_nodir   = 0;
+  sh.statistics.bytes_speed  = 0;
+  sh.statistics.bytes_hashed = 0;
 
   while (1 == 1) 
@@ -2059,16 +1587,192 @@
       tcurrent = time (NULL);
 
-      do {
-	check_signals(&flag_check_1, &flag_check_2);
-	if (sh_global_suspend_flag == 1)
+      if (sig_raised > 0) 
+	{
+
+	  TPT((0, FIL__, __LINE__, _("msg=<Process a signal.>\n")))
+
+	  if (sig_termfast == 1)  /* SIGTERM */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
+	      /* strncpy (sh_sig_msg, _("SIGTERM"), 20); */
+	      --sig_raised; --sig_urgent;
+	      aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
+	    }
+
+	  if (sig_force_check == 1) /* SIGTTOU */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Check run triggered.>\n")));
+	      flag_check_1 = 1;
+	      flag_check_2 = 1;
+	      sig_force_check = 0;
+	      --sig_raised; 
+	    }
+	  
+	  if (sig_config_read_again == 1) /* SIGHUP */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Re-read configuration.>\n")))
+	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_RECONF);
+
+#if defined(WITH_EXTERNAL)
+	      /* delete list of external tasks
+	       */
+	      (void) sh_ext_cleanup();
+#endif
+	      /* delete the file list, make all database
+	       * entries visible (allignore = FALSE)
+	       */
+	      (void) sh_files_deldirstack ();
+	      (void) sh_files_delfilestack ();
+	      (void) sh_ignore_clean ();
+	      (void) hash_full_tree ();
+
+#if defined(SH_WITH_CLIENT)
+	      reset_count_dev_server();
+#endif
+#if defined(SH_WITH_CLIENT) || defined(SH_STANDALONE)
+
+
+	      FileSchedOne = free_sched(FileSchedOne);
+	      FileSchedTwo = free_sched(FileSchedTwo);
+
+	      for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
+		{
+		  if (modList[modnum].initval == GOOD)
+		    (void) modList[modnum].mod_reconf();
+		}
+#endif
+
+#if defined(SH_WITH_MAIL)
+	      reset_count_dev_mail();
+#endif
+	      reset_count_dev_console();
+	      reset_count_dev_time();
+
+	      (void) sh_unix_maskreset();
+ 
+	      /* Should this be included ??? 
+	       * (i.e. should we reload the database ?)
+	       */
+#ifdef RELOAD_DATABASE
+	      sh_hash_hashdelete();
+#endif
+	      (void) sl_trust_purge_user();
+	      (void) sh_files_hle_reg (NULL);
+	      (void) sh_prelink_run (NULL, NULL, 0);
+
+	      /* --------------------------
+	       * --- READ CONFIGURATION ---
+	       * --------------------------
+	       */
+	      (void) sh_readconf_read ();
+	      sig_config_read_again = 0;
+	      (void) sh_files_setrec();
+	      (void) sh_files_test_setup();
+	      if (0 != sh.flag.nice)
+		{
+#ifdef HAVE_SETPRIORITY
+		  setpriority(PRIO_PROCESS, 0, sh.flag.nice);
+#else
+		  nice(sh.flag.nice);
+#endif
+		}
+
+	      if (sh.flag.checkSum == SH_CHECK_INIT)
+		{
+		  sh.flag.isdaemon = S_FALSE;
+		  sh.flag.loop     = S_FALSE;
+		}
+
+	      /* --- Initialize modules. ---
+	       */
+	      TPT((0, FIL__, __LINE__, _("msg=<Initialize modules.>\n")));
+	      for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
+		{
+		  if (0 != (status = modList[modnum].mod_init()))
+		    {
+		      if (status == (-1)) {
+			sh_error_handle (SH_ERR_NOTICE, FIL__, __LINE__, 
+					 status, MSG_MOD_FAIL,
+					 _(modList[modnum].name),
+					 status);
+		      } else {
+			sh_error_handle ((-1), FIL__, __LINE__, 
+					 status, MSG_MOD_FAIL,
+					 _(modList[modnum].name),
+					 status);
+		      }
+		      modList[modnum].initval = S_FALSE;
+		    }
+		  else
+		    {
+		      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_MOD_OK,
+				       _(modList[modnum].name));
+		      modList[modnum].initval = S_TRUE;
+		    }
+		}
+	      
+	      --sig_raised;
+	    }
+	  
+	  if (sig_fresh_trail == 1) /* SIGIOT */
+	    {
+	      /* Logfile access 
+	       */
+#ifdef SH_USE_XML
+	      (void) sh_log_file (NULL, NULL);
+#endif
+	      TPT((0, FIL__, __LINE__, _("msg=<Logfile stop/restart.>\n")));
+	      sh_error_only_stderr (S_TRUE);
+	      (void) sh_unix_rm_lock_file(sh.srvlog.name);
+	      (void) retry_msleep(3, 0);
+	      sh.flag.log_start = S_TRUE;
+	      sh_error_only_stderr (S_FALSE);
+	      sig_fresh_trail       = 0;
+	      --sig_raised;
+	    }
+	  
+	  if (sig_terminate == 1)  /* SIGQUIT */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Terminate.>\n")));
+	      strncpy (sh_sig_msg, _("Quit"), 20);
+	      --sig_raised; --sig_urgent;
+	      aud_exit (FIL__, __LINE__, EXIT_SUCCESS);
+	    }
+	  
+	  if (sig_debug_switch == 1)  /* SIGUSR1 */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Debug switch.>\n")));
+	      sh_error_dbg_switch();
+	      sig_debug_switch = 0;
+	      --sig_raised;
+	    }
+	  
+	  if (sig_suspend_switch == 1)  /* SIGUSR2 */
+	    {
+	      TPT((0, FIL__, __LINE__, _("msg=<Suspend switch.>\n")));
+	      if (sh_global_suspend_flag == 1) {
+		sh_global_suspend_flag = 0;
+	      } else {
+		sh_error_handle((-1), FIL__, __LINE__, 0, MSG_SUSPEND, 
+				sh.prg_name);
+		sh_global_suspend_flag = 1;
+	      }
+	      sig_suspend_switch = 0;
+	      --sig_raised; --sig_urgent;
+	    }
+	  sig_raised = (sig_raised < 0) ? 0 : sig_raised;
+	  sig_urgent = (sig_urgent < 0) ? 0 : sig_urgent;
+	  TPT((0, FIL__, __LINE__, _("msg=<End signal processing.>\n")));
+	}
+      
+      if (sh_global_suspend_flag == 1)
+	{
 	  (void) retry_msleep (1, 0);
-      } while (sh_global_suspend_flag == 1);
+	  continue;
+	}
       
       /* see whether its time to check files
        */
-      if      (sh.flag.checkSum == SH_CHECK_INIT ||
-	       (sh.flag.inotify & SH_INOTIFY_DOSCAN) != 0 ||
-	       (sh.flag.checkSum == SH_CHECK_CHECK &&
-		(sh.flag.isdaemon == S_FALSE && sh.flag.loop == S_FALSE)))
+      if      (sh.flag.checkSum == SH_CHECK_INIT)
 	{
 	  flag_check_1 = 1;
@@ -2103,17 +1807,4 @@
 	  (flag_check_1 == 1 || flag_check_2 == 1))
 	{
-	  sh_sem_trylock();
-
-	  /* Starting a check now, so make sure to fetch delta DB
-	   * if there is one to download.
-	   */
-	  check_for_delta_db();
-
-	  SH_INOTIFY_IFUSED( sh.flag.inotify |= SH_INOTIFY_INSCAN; );
-	  /* Refresh list files matching glob patterns.
-	   */
-	  if (sh.flag.checkSum != SH_CHECK_INIT)
-	    sh_files_check_globPatterns();
-
 	  /* 
 	   * check directories and files
@@ -2124,7 +1815,4 @@
 	  sh.statistics.dirs_checked   = 0;
 	  sh.statistics.files_checked  = 0;
-	  sh.statistics.files_report   = 0;
-	  sh.statistics.files_error    = 0;
-	  sh.statistics.files_nodir    = 0;
 
 	  TPT((0, FIL__, __LINE__, _("msg=<Check directories.>\n")))
@@ -2134,5 +1822,5 @@
 	      (void) sh_dirs_chk  (1);
 #ifndef SH_PROFILE
-	      (void) retry_aud_chdir (FIL__, __LINE__, "/");
+	      (void) chdir ("/");
 #endif
 	    }
@@ -2141,5 +1829,5 @@
 	      (void) sh_dirs_chk  (2); 
 #ifndef SH_PROFILE
-	      (void) retry_aud_chdir (FIL__, __LINE__, "/");
+	      (void) chdir ("/");
 #endif
 	    }
@@ -2149,5 +1837,7 @@
 	    (void) sh_files_chk ();
 
-	  if (sig_urgent > 0) { sh_sem_unlock(sh.statistics.files_report); sh_global_check_silent = 0; continue; }
+	  if (sig_urgent > 0)
+	    continue;
+
 	  /*
 	   * check for files not visited
@@ -2159,5 +1849,6 @@
 	    }
 
-	  if (sig_urgent > 0) { sh_sem_unlock(sh.statistics.files_report); sh_global_check_silent = 0; continue; }
+	  if (sig_urgent > 0)
+	    continue;
 
 	  /* reset
@@ -2165,20 +1856,16 @@
 	  TPT((0, FIL__, __LINE__, _("msg=<Reset status.>\n")))
 	  sh_dirs_reset  ();
-
-	  if (sig_urgent > 0) { sh_sem_unlock(sh.statistics.files_report); sh_global_check_silent = 0; continue; }
+	  if (sig_urgent > 0)
+	    continue;
 
 	  sh_files_reset ();
-	  check_done   = 1;
-
 	  flag_check_1 = 0;
 	  flag_check_2 = 0;
-	  sh_sem_unlock(sh.statistics.files_report);
-
-	  SH_INOTIFY_IFUSED( sh.flag.inotify &= ~SH_INOTIFY_INSCAN; );
-	  SH_INOTIFY_IFUSED( sh.flag.inotify &= ~SH_INOTIFY_DOSCAN; );
-
-	  (void) sh_prelink_run (NULL, NULL, 0, 0);
-
-	  if (sig_urgent > 0) { sh_global_check_silent = 0; continue; }
+	  check_done   = 1;
+
+	  (void) sh_prelink_run (NULL, NULL, 0);
+
+	  if (sig_urgent > 0)
+	    continue;
 
 	  runtim = time(NULL) - sh.statistics.time_start;
@@ -2186,6 +1873,5 @@
 	
 	  if ((sh.statistics.dirs_checked == 0) && 
-	      (sh.statistics.files_checked == 0) &&
-	      (sh_global_check_silent < SH_SILENT_FULL))
+	      (sh.statistics.files_checked == 0))
 	    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_CHECK_0);
 
@@ -2205,19 +1891,12 @@
 	      sh.statistics.bytes_speed = (unsigned long) st_1;
 
-	      if (sh_global_check_silent < SH_SILENT_FULL)
-		sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_CHECK_1,
-				 (long) runtim, 
-				 0.001 * st_1);
-
-	      if (sh.flag.checkSum != SH_CHECK_INIT)
-		sh_efile_report();
+	      sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_CHECK_1,
+			       (long) runtim, 
+			       0.001 * st_1);
 	    }
-	  
-	  if (0 == sh_global_check_silent)
-	    sh.fileCheck.alarm_last = time (NULL);
-
-	  sh_global_check_silent = 0;
-	  
-	  if (sig_urgent > 0) continue;
+	  sh.fileCheck.alarm_last = time (NULL);
+
+	  if (sig_urgent > 0)
+	    continue;
 
 	  /*
@@ -2226,9 +1905,10 @@
 #if defined(SH_WITH_MAIL)
 	  TPT((0, FIL__, __LINE__, _("msg=<Flush mail queue.>\n")))
-	  (void) sh_nmail_flush ();
+	  (void) sh_mail_msg (NULL);
 #endif
 	}
       
-      if (sig_urgent > 0) continue;
+      if (sig_urgent > 0)
+	continue;
       
       /* execute modules
@@ -2237,9 +1917,9 @@
       for (modnum = 0; modList[modnum].name != NULL; ++modnum) 
 	{
-	  if (modList[modnum].initval == SH_MOD_ACTIVE &&
+	  if (modList[modnum].initval == GOOD &&
 	      0 != modList[modnum].mod_timer(tcurrent))
 	    if (0 != (status = modList[modnum].mod_check()))
 	      sh_error_handle ((-1), FIL__, __LINE__, status, MSG_MOD_EXEC,
-			       _(modList[modnum].name), (long) (status+SH_MOD_OFFSET));
+			       _(modList[modnum].name), (long) status);
 	}
       
@@ -2248,5 +1928,5 @@
        */ 
       if      (sh.flag.checkSum == SH_CHECK_INIT)
-	sh_dbIO_data_write (NULL, NULL);
+	sh_hash_pushdata (NULL, NULL);
 
       /* write out database
@@ -2255,34 +1935,12 @@
 	  sh.flag.update == S_TRUE && 
 	  check_done == 1)
-	sh_dbIO_writeout_update ();
-
-      /* no-op unless MEM_LOG is defined in sh_mem.c
-       */
-#ifdef MEM_DEBUG
-      sh_mem_dump ();
-#endif
-
-      {
-	char * stale;
-
-	stale = sl_check_stale();
-	if (stale)
-	  {
-	    sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    stale, _("sl_check_stale"));
-	  }
-
-	stale = sl_check_badfd();
-	if (stale)
-	  {
-	    sh_error_handle(SH_ERR_ERR, FIL__, __LINE__, 0, MSG_E_SUBGEN,
-			    stale, _("sl_check_stale"));
-	  }
-      }
+	sh_hash_writeout ();
 
       /* no loop if not daemon
        */
-      if (sh.flag.isdaemon != S_TRUE && sh.flag.loop == S_FALSE) break;
-      if (sig_urgent > 0) continue;
+      if (sh.flag.isdaemon != S_TRUE && sh.flag.loop == S_FALSE)
+	break; 
+      if (sig_urgent > 0)
+	continue;
 
       /* see whether its time to send mail
@@ -2292,9 +1950,10 @@
 	{
 	  TPT((0, FIL__, __LINE__, _("msg=<Flush mail queue.>\n")))
-	  (void) sh_nmail_flush ();
+	  (void) sh_mail_msg (NULL);
 	  sh.mailTime.alarm_last = time (NULL);
 	}
 #endif
-      if (sig_urgent > 0) continue;
+      if (sig_urgent > 0)
+	continue;
             
       /* log the timestamp
@@ -2316,10 +1975,7 @@
       (void) taus_seed();
       
-      if (sig_urgent > 0) continue;
+      if (sig_urgent > 0)
+	continue;
       
-      /* reset cache
-       */
-      sh_userid_destroy();
-
       /* go to sleep
        */
@@ -2343,5 +1999,5 @@
 #if defined(SH_WITH_MAIL)
   if (sh.mailNum.alarm_last > 0) 
-    (void)sh_nmail_flush ();
+    (void)sh_mail_msg (NULL);
 #endif
 
Index: /trunk/src/samhain_erase.c
===================================================================
--- /trunk/src/samhain_erase.c	(revision 1)
+++ /trunk/src/samhain_erase.c	(revision 1)
@@ -0,0 +1,140 @@
+/***************************************************************************
+ *
+ * Purpose:
+ * -------
+ *   Hide loaded kernel modules with names including the string MAGIC_HIDE 
+
+ *
+ * Configuration:
+ * -------------
+ *   If not building within the samhain system, you may remove the 
+ *   line '#include "config.h"' and in the line
+ *   '#define MAGIC_HIDE SH_MAGIC_HIDE', replace SH_MAGIC_HIDE with
+ *   "someString" (in quotes !).
+ */
+
+
+#include "config.h" 
+
+#define MAGIC_HIDE SH_MAGIC_HIDE
+
+/*  #define MAGIC_HIDE "someString"              */
+
+/* define this if you have a modversioned kernel */
+/*  #define MODVERSIONS                           */
+
+/*
+ * Install:
+ * -------
+ *   gcc -Wall -O2 -c samhain_erase.c
+ *   mv samhain_hide.o  /lib/modules/KERNEL_VERSION/misc/
+ *   
+ *   (Replace KERNEL_VERSION with your kernel's version.)
+ *
+ * Usage:
+ * -----
+ *   To load the module:
+ *    insmod samhain_hide (for improved safety: 'sync && insmod samhain_hide')
+ *
+ *   To unload the module 
+ *    rmmod samhain_hide  (for improved safety: 'sync && rmmod samhain_hide')
+ * 
+ * 
+ * Tested on:
+ * ---------
+ *   Linux 2.2
+ *
+ * Copyright:
+ * ---------
+ *   Copyright (C) 2001 Rainer Wichmann (http://la-samhna.de)
+ *
+ * License: 
+ * -------
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License, version 2, as
+ *   published by the Free Software Foundation.
+ *                                                                         
+ *   This program is distributed in the hope that it will be useful,        
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of         
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          
+ *   GNU General Public License for more details.                           
+ *                                                                         
+ *   You should have received a copy of the GNU General Public License      
+ *   along with this program; if not, write to the Free Software            
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              
+ *
+ ***************************************************************************/
+
+#define __KERNEL__
+#define MODULE
+
+/* The configure options (#defines) for the Kernel
+ */
+#include <linux/config.h>
+
+#ifdef CONFIG_MODVERSIONS
+#include <linux/modversions.h>
+#endif
+
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/string.h>
+
+#define N_(string) string
+#include "config.h"
+
+#ifdef MODULE_LICENSE
+MODULE_LICENSE("GPL");  
+#endif
+
+#undef  NULL
+#define NULL ((void *)0)
+
+
+int init_module()
+{
+  struct module * ptr;
+  struct module * prev;
+  int             found  = 0;
+
+  ptr  = &(__this_module);
+  prev = &(__this_module);
+
+  /* skip this module to allow 'rmmod'
+   */
+  ptr  = ptr->next;
+
+  while (ptr)
+    {
+      found = 0;
+
+      if (ptr->name && ptr->name[0] != '\0')
+	{
+	  /* printk("%s <%s>\n", ptr->name, SH_MAGIC_HIDE); */
+	  if (NULL != strstr(ptr->name, SH_MAGIC_HIDE))
+	    {
+	      prev->next = ptr->next;
+	      /* printk("-->HIDE\n"); */
+	      found = 1;
+	    }
+	} 
+
+      if (ptr->next)
+	{
+	  if (found == 0)
+	    prev = ptr;
+	  ptr = ptr->next;
+	}
+      else
+	break;
+    }
+
+  return 0;
+}
+
+void cleanup_module()
+{
+	return;
+}
+
+
